tquaternion ttrack::getq(int sel, int n) {
  tkey *kn_1, *kn, *kn1;
  tquaternion *qn_1, *qn, *qn1;
  int d1, d2;

  kn = (tkey *) track[n];
  qn = (tquaternion *) kn->d;

  if (sel == point) return *qn;

  if (n == 0) {
    //first key
    kn1 = (tkey *) track[1];
    qn1 = (tquaternion *) kn1->d;

    //2 keys
//  if (track.count == 2) return qn->slerp(*qn1,(1.0 - kn->tension)/3.0);

    if (mode != 3 || track.count <= 2) {
      //first key, no loop
//    return qn->slerp(getq(an,1),(1.0 - kn->tension)*0.5);
      return qn->slerp(*qn1,
             (1.0 - kn->tension)*(1.0 + kn->continuity*kn->bias)/3.0);
    } else {
      //first key, loop
      kn_1= (tkey *) track[track.count-2];
      d1 = ((tkey *) track[track.count-1])->frame - kn_1->frame;
      d2 = kn1->frame - kn->frame;
    };
  } else if (n == track.count-1) {
    //last key
    kn_1 = (tkey *) track[n-1];
    qn_1 = (tquaternion *) kn_1->d;

    //2 keys
//  if (track.count == 2) return qn->slerp(*qn_1,(1.0 - kn->tension)/3.0);

    if (mode != 3 || track.count <= 2) {
      //last key, no loop
//    return qn->slerp(getq(bn,n-1),(1.0 - kn->tension)*0.5);
      return qn->slerp(*qn_1,
             (1.0 - kn->tension)*(1.0 - kn->continuity*kn->bias)/3.0);
    } else {
      //last key, loop
      kn1 = (tkey *) track[1];
      d1 = kn->frame - kn_1->frame;
      d2 = kn1->frame - ((tkey *) track[0])->frame;
    };
  } else {
    //middle keys
    kn_1= (tkey *) track[n-1];
    kn1 = (tkey *) track[n+1];
    d1 = kn->frame - kn_1->frame;
    d2 = kn1->frame - kn->frame;
  };
  qn_1= (tquaternion *) kn_1->d;
  qn1 = (tquaternion *) kn1->d;

  float f;
  float adjust;

  if (sel == an) {
    f = 1.0;
    adjust = d1;
  } else {
    f = -1.0;
    adjust = d2;
  };
  adjust /= d1 + d2;
  adjust = 0.5 + (1.0 - fabs(kn->continuity))*(adjust - 0.5);

  tquaternion g1 = qn->slerp(*qn_1,-(1.0 + kn->bias)/3.0);
  tquaternion g2 = qn->slerp(*qn1 , (1.0 - kn->bias)/3.0);

  return qn->slerp(g1.slerp(g2,0.5 + f*0.5*kn->continuity),
         f*(kn->tension - 1.0)*adjust*2.0);
};
